'=======================================================================
'UPDATED 06/15/94
' Copyright (C) Sidney J. Kelly, All rights Reserved
'=======================================================================
DEFINT A-Z

 ' Returns coprocessor type
 ' Does rely on Equipment word as does QBX, because of clone errors.
DECLARE FUNCTION CHECK87% ()

' Returns detailed CPU type information
DECLARE FUNCTION CHIPTYPE% ()


PRINT "Processors:    ";

TCPU% = CHIPTYPE%   ' determine CPU type
TNDP% = CHECK87%    ' determine math chip
SELECT CASE TCPU%
	CASE 386            ' only works for newer chips
		PRINT "80386DX";
	CASE 376            ' only works for newer chips
		PRINT "80386SX";  '(likely an AMD)
	CASE -386
		PRINT "80386 (Prot. Mode)";
	CASE 486, -486
		PRINT "80486";
		IF TNDP% <= 0 THEN
			PRINT "SX";
		ELSE
			PRINT "DX";
		END IF
		IF TCPU% < 0 THEN PRINT " (Prot. Mode)";
	CASE 586, -586
		PRINT "PENTIUM":
		IF TCPU% < 0 THEN PRINT " (Prot. Mode)";
	CASE 480, -480
		PRINT "IBM 486SLC";
		IF TCPU% < 0 THEN PRINT " (Prot. Mode)";
	CASE 479
		PRINT "486DLC";
	CASE 286
		PRINT "80286";
	CASE 88             'PC PC/XT
		PRINT "8088";
	CASE 86             'Systempro  AT&T/Olivetti
		PRINT "8086";
	CASE 186
		PRINT "80186";
	CASE 32
		PRINT "NEC V20";
	CASE 30
		PRINT "NEC V30";
	CASE 188       ' very unlikely to find this
		PRINT "80188";
	CASE ELSE
		PRINT "Unknown";
END SELECT

PRINT " with";
SELECT CASE TNDP%
	CASE 0
		PRINT "out a math";
	CASE -87
		PRINT " a software emulator";
	CASE 87
		PRINT " an 8087";
	CASE 287
		PRINT " an 80287";
	CASE 1287
		PRINT " an 80C287A";  '387 for 287 slot
	CASE ELSE    '387 chip of some kind
		SELECT CASE TCPU%
			CASE 486, -486
				PRINT " an 80487";
			CASE 586, -586
				PRINT " an 80587";
			CASE ELSE
				PRINT " an 80387";
		END SELECT
	END SELECT
PRINT " coprocessor."
END

