
 
 REM   *********************************************************************
 REM   *                                                                   *
 REM   *    PROGRAM:  DOS                                                  *
 REM   *                                                                   *
 REM   *    DESCRIPTION: DOS FUNCTIONS FOR QUICK BASIC                     *
 REM   *                                                                   *
 REM   *                                                                   *
 REM   *    08/05/87     JOHN M. TAL                                       *
 REM   *                 ROLLINS MEDICAL/DENTAL SYSTEMS                    *
 REM   *                 SOUTHFIELD, MI                                    *
 REM   *                                                                   *
 REM   *                                                                   *
 REM   *********************************************************************
 
 REM   LAST EDIT:  08/05/87      PROGRAMMER: JMT
 
 
 OPTION BASE 1
 DEFDBL A-Z
 
 
 
 DIM INREG%(10),OUTREG%(10)
 COMMON SHARED INREG%(),OUTREG%(),AX%,BX%,CX%,DX%,DP%,SI%,DI%,FL%,DS%,ES%
 
 AX% = 1
 BX% = 2
 CX% = 3
 DX% = 4
 BP% = 5
 SI% = 6
 DI% = 7
 FL% = 8
 DS% = 9
 ES% = 10
 
  DEF FNWORD%(N!)  
  REM --------------------------------------------
  REM  CONVERT A SINGLE PRECISION NUMBER 0 - 65535
  REM  INTO EQUIVELANT WORD/INTEGER(%) FOR USE BY
  REM  CALL INT86
  REM --------------------------------------------
 
    IF N! > 32767 THEN
       FNWORD% = N! - 65536
    ELSE
       FNWORD% = N!
    END IF
 
  END DEF  REM FNWORD%
 
 
  DEF FNWORD!(N%)  
  REM --------------------------------------------
  REM  CONVERT A WORD INTO SINGLE PRECISION 
  REM  NUMBER 0 - 65535
  REM --------------------------------------------
 
    IF N% < 0 THEN
       FNWORD! = N% + 32767
    ELSE
       FNWORD! = N%
    END IF
 
  END DEF  REM FNWORD!
 
 
 
  DEF FNSMOD%(N!,M!)
    WHILE N! > M!
      N! = N! - M!
    WEND
    FNSMOD% = FNWORD%(N!)
  END DEF   REM FNSMOD%
 
 SUB MSDOS STATIC
    CALL INT86(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 SUB MSDOSX STATIC
    CALL INT86X(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 
 REM  &H00 PROGRAM TERMINATE
 REM  &H01 KEYBOARD INPUT
 REM  &H02 DISPLAY OUTPUT
 REM  &H03 AUXILIARY INPUT
 REM  &H04 AUXILIARY OUTPUT
 REM  &H05 PRINTER OUTPUT
 REM  &H06 DIRECT CONSOLE I/O
 REM  &H07 DIRECT CONSOLE INPUT WITHOUT ECHO 
 REM  &H08 CONSOLE INPUT WITHOUT ECHO
 REM  &H09 PRINT (DISPLAY) STRING
 REM  &H0A BUFFERED KEYBOARD INPUT
 REM  &H0B CHECK STANDARD INPUT STATUS
 REM  &H0C CLEAR KEYBOARD BUFFER AND INVOKE A KEYBOARD FUNCTION
 REM  &H0D DISK RESET
 
 SUB SELDISK(DRIVE%) STATIC 
    INREG%(AX%) = &H0E00 + DRIVE%
 END SUB
    
 REM  &H0F FCB OPEN FILE
 REM  &H10 FCB CLOSE FILE
 REM  &H11 FCB SEARCH FIRST FILE
 REM  &H12 FCB SEARCH NEXT FILE
 REM  &H13 FCB DELETE FILE
 REM  &H14 FCB SEQUENTIAL READ
 REM  &H15 FCB SEQUENTIAL WRITE
 REM  &H16 FCB CREATE FILE
 REM  &H17 FCB RENAME FILE
 
 SUB CURDRIVE(DRIVE%) STATIC
    INREG%(AX%) = &H1900
    CALL MSDOS
    DRIVE% = OUTREG%(AX%) MOD 256
 END SUB
 
 REM  &H1A SET DTA
 REM  &H1B ALLOCATION TABKE INFORMATION / DEFAULT DRIVE
 REM  &H1C ALLOCATION TABLE INFORMATION FOR SPECIFIC DEVICE / DRIVE INFO
 REM  &H21 RANDOM READ
 REM  &H22 RANDOM WRITE
 REM  &H23 FCB FILE SIZE
 REM  &H24 FCB SET RELATIVE RECORD FIELD
 REM  &H25 SET INTERRUPT VECTOR
 REM  &H26 CREATE NEW PROGRAM SEGMENT
 REM  &H27 FCB RANDOM BLOCK READ
 REM  &H28 FCB RANDOM BLOCK WRITE
 REM  &H29 FCB PARSE FILENAME
 REM  &H2A GET DATE
 REM  &H2B SET DATE
 REM  &H2C GET TIME
 REM  &H2D SET TIME
 
 SUB VERIFY(VSWITCH%) STATIC
    INREG%(AX%) = &H2E + VSWITCH%
    CALL MSDOS
 END SUB
 
 SUB GETDTA(DTA.SEG%,DTA.OFS%) STATIC
   INREG%(AX%)= &H2F00
   CALL MSDOSX
   DTA.SEG% = OUTREG%(ES%)
   DTA.OFS% = OUTREG%(BX%)
 END SUB
 
 SUB GETDOSV(MAJOR%,MINOR%) STATIC
   INREG%(AX%) = &H3000
   CALL MSDOS
   MAJOR% = OUTREG%(AX%) MOD 256
   MINOR% = OUTREG%(AX%) \ 256
 END SUB
 
 REM  &H31 TERMINATE AND STAY RESIDENT
 REM  &H33 CONTROL BREAK CHECK
 REM  &H35 GET VECTOR
 
 SUB GETDISKFREE(DRIVE%,DFREE!,DMAX!) STATIC
    INREG%(AX%) = &H3600
    INREG%(DX%) = DRIVE%
    CALL MSDOS
    AVAIL.CL! = FNWORD!(OUTREG%(BX%))
    CL.DRIVE! = FNWORD!(OUTREG%(DX%))
    BYTE.SEC! = FNWORD!(OUTREG%(CX%))
    SEC.P.CL! = FNWORD!(OUTREG%(AX%))
    IF SEC.P.CL! = &HFFFF THEN   REM INVALID DRIVE
      DFREE! = -1
      DMAX! = -1
    ELSE
      DFREE! = AVAIL.CL! * SEC.P.CL! * BYTE.SEC!
      DMAX! = CL.DRIVE! * SEC.P.CL! * BYTE.SEC!
    END IF
 END SUB
 
 REM  &H38 COUNTRY DEPENDENT INFORMATION
 
 SUB MAKEDIR(F$,RES%) STATIC
    INREG%(AX%) = &H3900
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
    END IF
 END SUB
 
 SUB REMDIR(F$,RES%) STATIC
    INREG%(AX%) = &H3A00
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
    END IF
 END SUB
 
 SUB CHGDIR(F$,RES%) STATIC
    INREG%(AX%) = &H3B00
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
    END IF
 END SUB
 
 SUB CREAT(F$,ATTRIB%) STATIC
    INREG%(AX%) = &H3C00
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
    END IF
 END SUB
 
 SUB OPENFILE(F$,OMODE%,FHANDLE%) STATIC
    INREG%(AX%) = &H3D00 + OMODE%   REM AH = &H3D, AL = OMODE% 
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1
    CALL INT86X(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
    IF (OUTREG%(FL%) AND 1) <> 1 THEN    REM CARRY NOT SET
       FHANDLE% = OUTREG%(AX%)
    ELSE 
       FHANDLE% = -1
    END IF
 END SUB
 
 SUB CLOSEFILE(FHANDLE%) STATIC
    INREG%(AX%) = &H3E00   REM CLOSE FILE
    INREG%(BX%) = FHANDLE%
    CALL INT86(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 SUB READFILE(FHANDLE%,BUF.SEG!,BUF.ADR!,BYTES%) STATIC
    REM CALL READFILE(FHANDLE%,-1,SADD(BUFFER$),255)
    INREG%(AX%) = &H3F00   REM READ FROM FILE
    INREG%(BX%) = FHANDLE%
    INREG%(DS%) = FNWORD%(BUF.SEG!)
    INREG%(DX%) = FNWORD%(BUF.ADR!)
    INREG%(CX%) = BYTES%
    CALL INT86X(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 SUB WRITEFILE(FHANDLE%,BUF.SEG!,BUF.ADR!,BYTES%) STATIC
    INREG%(AX%) = &H4000   REM WRITE TO FILE
    INREG%(BX%) = FHANDLE%
    INREG%(CX%) = BYTES%        REM TRUNCATE FILE
    INREG%(DX%) = FNWORD%(BUF.ADR!)
    INREG%(DS%) = FNWORD%(BUF.SEG!)
    CALL INT86X(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 SUB UNLINK(F$) STATIC
    INREG%(AX%) = &H4100
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
    END IF
 END SUB
 
 SUB LSEEK(FHANDLE%,SMODE%,FLEN!) STATIC
    INREG%(AX%) = &H4200 + SMODE%   REM AH = &H42, AL = SMODE%/SEEK MODE
    INREG%(CX%) = INT(FLEN! / 65536)
    INREG%(DX%) = FNSMOD%(FLEN!,65536)
    INREG%(BX%) = FHANDLE%
    CALL INT86(&H21,VARPTR(INREG%(AX%)),VARPTR(OUTREG%(AX%)))
 END SUB
 
 SUB CHMOD(F$,ATTRIB%,FUNC%) STATIC
    INREG%(AX%) = &H4300 + FUNC%       
    INREG%(DX%) = SADD(F$+CHR$(0))
    INREG%(DS%) = -1  REM QUICK BASIC'S DATA SEGMENT
    INREG%(CX%) = ATTRIB%
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET = ERROR
      RES% = OUTREG%(AX%)
    ELSE
      RES% = 0
      ATTRIB% = OUTREG%(CX%)  REM ATTRIB RETURNED IF FUNCTION IS GETTING
    END IF
 END SUB
 
 REM  &H44 I/O CONTROL FOR DEVICES (IOCTL)
 REM  &H45 DUPLICATE A FILE HANDLE (DUP)
 REM  &H46 FORCE A DUPLICATE OF A HANDLE (FORCDUP)
 
 SUB GETCURDIR(BUFFER$,DRIVE%) STATIC
    INREG%(AX%) = &H4700 
    INREG%(SI%) = SADD(BUFFER$)  REM BUFFER$ = 64 BYTES
    INREG%(DS%) = -1  REM QUICK BASICS DATA SEGMENT
    INREG%(DX%) = DRIVE%
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1) = 1 THEN  REM CARRY SET
       DRIVE% = -1   
    END IF
 END SUB
 
 REM  &H48 ALLOCATE MEMORY
 REM  &H49 FREE ALLOCATED MEMORY
 REM  &H50 MODIFY ALLOCATED MEMORY BLOCKS (SETBLOCK)
 REM  &H4B LOAD OR EXECUTE A PROGRAM (EXEC)
 REM  &H4C TERMINATE A PROCESS (EXIT)
 REM  &H4D GET RETURN CODE OF A SUBPROCESS (WAIT)
 
 
 SUB GETFIRST(SEARCH$,ATTRIB%) STATIC
    INREG%(AX%) = &H4E00
    INREG%(CX%) = ATTRIB%  REM ATTRIBUTE
    INREG%(DX%) = SADD(SEARCH$+CHR$(0))
    INREG%(DS%) = -1
    CALL MSDOSX
    IF (OUTREG%(FL%) AND 1 ) = 1 THEN
       ATTRIB% = -1
    END IF
 END SUB
 
 SUB GETNEXT(NERR%) STATIC
    INREG%(AX%) = &H4F00
    CALL MSDOS
    IF (OUTREG%(FL%) AND 1) = 1 THEN
       NERR% = OUTREG%(AX%)
    ELSE
       NERR% = 0
    END IF
 END SUB
 
 SUB GETVERIFY(VER%) STATIC
    INREG%(AX%) = &H5400
    CALL MSDOS
    VER% = OUTREG%(AX%) MOD 256
 END SUB
 
 REM  &H56 RENAME A FILE
 REM  &H57 GET/SET A FILES DATE AND TIME
 
 SUB GETXERROR(EXERR!,ERCLASS%,SUGGACT%,LOCUS%) STATIC
    INREG%(AX%) = &H5900
    INREG%(BX%) = 0   REM DOS 3.00 TO 3.30
    CALL MSDOS
    EXERR! = FNWORD!(OUTREG%(AX%))
    ERCLASS% = OUTREG%(BX%) \ 256
    SUGACT% = OUTREG%(BX%) MOD 256
    LOCUS% = OUTREG%(CX%) \ 256
 END SUB
 
 REM  &H5A CREATE UNIQUE FILE
 REM  &H5B CREATE NEW FILE
 REM  &H5C LOCK/UNLOCK FILE ACCESS
 
 REM  ---  NETWORK SUPPORT ---
 REM  &H5E00 GET MACHINE NAME
 REM  &H5E02 SET PRINTER SETUP
 REM  &H5E03 GET PRINTER SETUP
 REM  &H5F02 GET REDIRECTION LIST ENTRY
 REM  &H5F03 REDIRECT DEVICE
 REM  &H5F04 CANCEL REDIRECTION
 
 REM  &H62 GET PROGRAM SEGMENT PREFIX ADDRESS (PSP)
 REM  &H65 GET EXTENDED COUNTRY INFORMATION
 REM  &H66 GET/SET GLOBAL CODE PAGE (CHARACTER SET)
 REM  &H67 SET HANDLE COUNT
 REM  &H68 COMMIT FILE 
 
 
 REM ------ SPECIAL CONGLOMERATES OF ABOVE FUNCTIONS --------
 
 
 SUB TRUNCFILE(F$,FLEN!) STATIC 
   REM TRUNCATATES FILE (F$) AT LENGTH (FLEN!)
   CALL OPENFILE(F$,2,FHANDLE%)
   IF FHANDLE% <> -1 THEN 
     CALL LSEEK(FHANDLE%,0,FLEN!)
     IF (OUTREG%(FL%) AND 1) <> 1 THEN  REM CARRY NOT SET
        CALL WRITEFILE(FHANDLE%,-1,0,0)
     END IF
     CALL CLOSEFILE(FHANDLE%)
   END IF
 END SUB
 
 
 SUB DIRFILE(FIRST%,SEARCH$,FOUND$) STATIC
 
 REM  CALL DIRFILE(1,"*.BAS",FOUND$)   INITS SEARCH$ AND RETURNS FIRST FOUND$
 REM  CALL DIRFILE(2,"*.BAS",FOUND$)   USE ANY VALUE OTHER THAN 1 TO GET NEXT
 REM                                     ANY CALL CAN RETURN "EOF"
 REM                                     WHICH MEANS NO MORE FILES
 REM
 
 FOUND$ = ""
 IF FIRST% = 1 THEN
   REM GET DTA
   CALL GETDTA(DTA.SEG%,DTA.OFS%)
 
   REM MAKE SURE SET TO BASIC SEGMENTS
   DEF SEG
 
   ATTRIB% = 0  
   CALL GETFIRST(SEARCH$,ATTRIB%)
 
   IF ATTRIB% <> -1 THEN  REM NO FILES
     DEF SEG = DTA.SEG%
     I% = DTA.OFS%+30
     B% = PEEK(I%)
     WHILE (I% < DTA.OFS%+42) AND (B% <> 0)
       FOUND$ = FOUND$ + CHR$(B%)
       I%=I%+1
       B% = PEEK(I%)
     WEND
   ELSE
     FOUND$ = "EOF"
   END IF
 
 ELSE   REM NOT FIRST CALL
 
   CALL GETNEXT(NERR%)
 
   IF NERR% = 0 THEN
     DEF SEG = DTA.SEG%
     I% = DTA.OFS%+30
     B% = PEEK(I%)
     WHILE (I% < DTA.OFS%+42) AND (B% <> 0)
       FOUND$ = FOUND$ + CHR$(B%)
       I%=I%+1
       B% = PEEK(I%)
     WEND
   
   ELSE   REM LAST FILE
     FOUND$ = "EOF"
   END IF
 
 
 END IF
 
 
 END SUB
 
 
