DEFINT A-Z
' ===========================================================================
'
' PROLIB71.BI
'
' ===========================================================================
' GLOBAL CONSTANTS
' ===========================================================================

CONST MINROW = 2
CONST MAXROW = 25
CONST MINCOL = 2
CONST MAXCOL = 80
CONST MAXMENU = 10
CONST MAXITEM = 20
CONST MAXWINDOW = 10

CONST BLACK = 0
CONST BLUE = 1
CONST GREEN = 2
CONST CYAN = 3
CONST RED = 4
CONST MAGENTA = 5
CONST BROWN = 6
CONST WHITE = 7
CONST DARKGREY = 8
CONST LIGHTBLUE = 9
CONST LIGHTGREEN = 10
CONST LIGHTCYAN = 11
CONST LIGHTRED = 12
CONST LIGHTMAGENTA = 13
CONST YELLOW = 14
CONST BRIGHTWHITE = 15

CONST YES = 1
CONST NO = 0
CONST TRUE = YES
CONST FALSE = NO

CONST F1 = 59
CONST F2 = 60
CONST F3 = 61
CONST F4 = 62
CONST F5 = 63
CONST F6 = 64
CONST F7 = 65
CONST F8 = 66
CONST F9 = 67
CONST F10 = 68

CONST SHIFT = 25
CONST CONTROL = 35
CONST ALT = 45

CONST SHIFTTAB = 15
CONST HOME = 71
CONST UPK = 72
CONST PGUP = 73
CONST LEFTK = 75
CONST RIGHTK = 77
CONST ENDK = 79
CONST DOWNK = 80
CONST PGDN = 81
CONST INSERTK = 82
CONST DELETEK = 83
CONST CTRLPRTSCR = 114
CONST CTRLLEFTARROW = 115
CONST CTRLRIGHTARROW = 116
CONST CTRLEND = 117
CONST CTRLPGDN = 118
CONST CTRLHOME = 119
CONST CTRLPGUP = 132
CONST SPACE = 32, ESC = 27, ENTER = 13, TABKEY = 9
CONST NULL = 0
CONST CTRLE = 5, CTRLD = 4, CTRLG = 7, CTRLH = 8, CTRLS = 19, CTRLV = 22

'functions in PROLIB71.ASM

DECLARE SUB getcopybox (row1%, col1%, row2%, col2%, buffer$)
DECLARE SUB putcopybox (ROW%, col%, buffer$)
DECLARE SUB attrbox (row1%, col1%, row2%, col2%, attr%)

DECLARE SUB Colorwind (row1%, col1%, row2%, col2%, char%, wclear%, foreground%, background%)
DECLARE SUB drawwind (row1%, col1%, row2%, col2%, frame%, clearflag%)
DECLARE SUB pnc (a$, ROW%, col%, foreground%, background%)
DECLARE SUB captal (a$)
DECLARE SUB clrkeybuf ()

DECLARE SUB setflag (flag%)     'SET FLAG
DECLARE SUB resetflag (flag%)   'RESET FLAG
DECLARE SUB clearall            'CLEAR ALL FLAGS
DECLARE FUNCTION getflag (flag%) 'GET STATE OF FLAG

DECLARE SUB GetRomDate (romdate$)
DECLARE SUB GetRam (ram%, EXTram%, EXPram%)
DECLARE FUNCTION GetNumLPT% ()
DECLARE FUNCTION GetNumCom% ()
DECLARE FUNCTION GetNumFlop% ()
DECLARE FUNCTION GetNumGames% ()
DECLARE FUNCTION GetNumHard% ()
DECLARE FUNCTION CPUcheck% ()
DECLARE FUNCTION VIDEOcheck% ()

'function and subs in PROLIB.LIB

DECLARE SUB DspEquipment () 'displays all equipment above in window

DECLARE FUNCTION GetShiftState% (bit%)
DECLARE SUB CapsOn ()
DECLARE SUB CapsOff ()
DECLARE SUB GetSingle (keycode%, codetype%)
DECLARE SUB waitkey (ROW%, fg%, bg%)

DECLARE SUB Reg8to16 (Reg16 AS LONG, RegHigh AS INTEGER, RegLow AS INTEGER)
DECLARE SUB Reg16to8 (Reg16 AS LONG, RegHigh AS INTEGER, RegLow AS INTEGER)
DECLARE SUB Reg8to4 (Reg8 AS INTEGER, RegHigh AS INTEGER, RegLow AS INTEGER)

DECLARE SUB AskQuestion (mop$(), numlines, Border, DispPos, FrmFG, FrmBG, GenFG, GenBG, Ques$, ans$)
DECLARE SUB Message (mop$(), lines%, Border%, FrmFG%, FrmBG%, GenFG%, GenBG%)

DECLARE SUB GetBackground (row1%, col1%, row2%, col2%, buffer$)
DECLARE SUB PutBackground (ROW%, col%, buffer$)

DECLARE SUB keysort (List$(), numelements%, Startpos%, Sortlen%)
DECLARE SUB quicksort (fl$(), Elements%)

DECLARE FUNCTION MenuBar% (ROW%, col%, MenuStr$, MenuFore%, MenuBack%, Reversed%, SP%)
DECLARE FUNCTION MenuWindow% (ROW%, col%, MenuStr$, title$, MenuFore%, MenuBack%, Reversed%, allowesc%)
DECLARE FUNCTION SelBox% (TempKey$(), numele%, lenview%, diswide%, fg%, bg%, rev%)

DECLARE SUB DialogBox (Ques$(), Before%, After%, LENGTH%, FrmFG%, FrmBG%, GenFG%, GenBG%, DispPos%, Answer$, format$, Ek%)
DECLARE SUB DrawBox (TopRow%, LeftCol%, Wid%, height%, FrameType%, FrmFgd%, FrmBgd%, Fill%, FillFgd%, FillBgd%, Shadow%)

DECLARE FUNCTION OpenFile% (FileName$, reclen%)
DECLARE FUNCTION FileExists% (FeName$)
DECLARE FUNCTION GetFileCount% (filespec$)
DECLARE FUNCTION SelFiles$ (ans$)

DECLARE FUNCTION GetPassword$ (FrmFG%, FrmBG%, GenFG%, GenBG%, DispPos%, Ek%)
DECLARE FUNCTION GetDate$ ()
DECLARE FUNCTION CheckFunction% (ch%)
DECLARE FUNCTION CheckPrinter% ()

DECLARE FUNCTION Minimum% (v1%, v2%)
DECLARE FUNCTION Maximum% (v1%, v2%)

DECLARE FUNCTION FEN$ (SB%, EFG%, EBG%, work$, format$, Exitcode%, UPflag%, PGUPflag%, DNflag%, PGDNflag%, RETflag%, TABflag%, escflag%)
DECLARE FUNCTION FES$ (SB%, EFG%, EBG%, work$, format$, caseflag%, Exitcode%, UPflag%, PGUPflag%, DNflag%, PGDNflag%, RETflag%, TABflag%, escflag%, F10flag%)
DECLARE FUNCTION userNformat$ (wrk$, format$)
DECLARE FUNCTION userSformat$ (wrk$, format$)
DECLARE FUNCTION RemoveCHAR$ (userstring$, skip$)
DECLARE FUNCTION removeformat$ (work$, format$)
DECLARE SUB FormatDEC (number$, beforeDEC%, afterdec%)

DECLARE FUNCTION Str2Token$ (Srce$, DELIM$)

DECLARE SUB Trim (a$)
DECLARE SUB CenterText (mop$, ROW%, fg%, bg%)
DECLARE SUB CenterPrn (mop$, PW%)
DECLARE SUB MsgLine (msg$, lin%, mfg%, mfb%)
DECLARE SUB PadStr (a$, b%)

'  STANDARD Routine Definitions

'Define Data Types

TYPE MenuData
   WordStart  AS INTEGER
   WordLen    AS INTEGER
   MenuLetter AS STRING * 1
   MenuWord   AS STRING * 40
END TYPE

'Declare Functions

'menu option

   DIM SHARED moption$(20)
   DIM SHARED MsgOpt$(6)  '  Scroll Box & Message Values

