'*************************************************************************
'*                                                                       *
'*                                                                       *
'*                        FileManager.BAS                                *
'*                                                                       *
'*                        A PUBLIC DOMAIN PROGRAM                        *
'*                                                                       *
'*                        By Carmen Paone                                *
'*                                                                       *
'*                                                                       *
'*************************************************************************
' This is the first version of FileManager. Improvements will be forthcoming.
' This program was designed to work with a floppy disk and assumes a default
' of whatever drive your are on. Check the QuickBasic manual or the built-in
' help files in QBASIC or QUICKBASIC to change drives and modify the program.
'
' I need your input on how to improve FileManager. Contact me on:
'               CIS AS CARMEN PAONE [72667, 42]
'               GENIE AS C.PAONE
'               DELPHI AS CARMENPAONE
'
' ===============================HINTS====================================
'
' -------------------------------QUICK RETURN-----------------------------
' If you are using Any Basic, Kill or Name functions, and you want to make
' a quick exit, just strike the ENTER key and you will be returned to the
' main menu.
'
'----------------------------LOOP TO FILEMANAGER--------------------------
' For a return to the FileManager menu from a preset BASIC program, include
' a subroutine such as this one:
'                SUB MenuReturn
'                RUN "MANAGER"
'                END SUB
'
'---------------------------BAD FILE NAME---------------------------------
' The error handling routine could be better. If there are no files on the
' disk such as "COM," error handling will flash the "NO SUCH FILES"
' message the first time and return you to main menu. However, it won't
' work the second time during use of program. Just restart the program by
' hitting the ESC key and than F6 and F5.
'
'--------------------------PRESET PROGRAMS-------------------------------
' You can call up to eight of your favorite QUICKBASIC programs with
' FileManager by changing the lines in the SUB "BasicSelect" first in
' in the select line from "PROGRAM #1" to the name of your program.
' Go down to the select case portion and look for "CASE 1." Change
' "PROGRAM #1" to the name of your program. Repeat the process for other
' such changes.
'
'-------------------------DISABLING PROGRAM ELEMENTS-------------------
' Place a ' before any of the program elements to disable it. For example,
' in the preset basic selection mode, you might want to only call 5 programs
' and then you can disable the other CASES to avoid errors.
'
'-------------------------MASS KILLS-------------------------------------
' Mass killing of files is possible by selecting option 4 and typing
' *.BAS, *.EXE, *.BAK, etc. and then hitting ENTER. Look over the files
' listing to make sure that's what you want to do.
'
'=======================================================================
' Main program or "SAW SUB, SANK SAME"

DECLARE SUB AnyBasic ()
DECLARE SUB BasicSelect ()
DECLARE SUB BoxDraw ()
DECLARE SUB CreditSign ()
DECLARE SUB KillAll ()
DECLARE SUB KillBas ()
DECLARE SUB KillCom ()
DECLARE SUB KillExe ()
DECLARE SUB KillFile ()
DECLARE SUB NameAll ()
DECLARE SUB NameBas ()
DECLARE SUB NameCom ()
DECLARE SUB NameExe ()
DECLARE SUB NameFile ()
DECLARE SUB ReturnLine ()
DECLARE SUB TipTop ()
DECLARE SUB ToSystem ()
DECLARE FUNCTION Handler ()


' Start of program

        CALL TipTop

' Less than efficient error handling routine

Handler:
        
        Number = 53
        IF ERR = 53 THEN GOTO WaitUp

WaitUp:
        CLS
        LOCATE 13, 25: COLOR 15, 0: PRINT "NO SUCH FILES": COLOR 7, 0
        SLEEP 3
        CALL TipTop

SUB AnyBasic
        
        CLS
        CALL CreditSign
        PRINT STRING$(80, 205)
        LOCATE 5, 25: COLOR 15, 0: PRINT "RUN ANY BASIC PROGRAM": COLOR 7, 0
        LOCATE 7, 1: PRINT STRING$(80, 205)
        LOCATE 9, 1: FILES "*.BAS"
        ON ERROR GOTO Handler
        
        LOCATE 15, 25: LINE INPUT "Name of program:   "; FileName$
        IF FileName$ = "" THEN CALL TipTop ELSE RUN FileName$ + ".BAS"
END SUB

SUB BasicSelect
        ON ERROR GOTO Handler
        CALL BoxDraw
        CALL CreditSign
        LOCATE 5, 25: PRINT "CALLING PRESET BASIC PROGRAMS"
        LOCATE 7, 15: COLOR 15, 0: PRINT "{ 1 }": COLOR 7, 0
        LOCATE 7, 22: PRINT "BOXMAKER"
        LOCATE 9, 15: COLOR 15, 0: PRINT "{ 2 }": COLOR 7, 0
        LOCATE 9, 22: PRINT "REMLINE"
        LOCATE 11, 15: COLOR 15, 0: PRINT "{ 3 }": COLOR 7, 0
        LOCATE 11, 22: PRINT "PROGRAM #3"
        LOCATE 13, 15: COLOR 15, 0: PRINT "{ 4 }": COLOR 7, 0
        LOCATE 13, 22: PRINT "PROGRAM #4"
        LOCATE 7, 50: COLOR 15, 0: PRINT "{ 5 }": COLOR 7, 0
        LOCATE 7, 57: PRINT "PROGRAM #5"
        LOCATE 9, 50: COLOR 15, 0: PRINT "{ 6 }": COLOR 7, 0
        LOCATE 9, 57: PRINT "PROGRAM #6"
        LOCATE 11, 50: COLOR 15, 0: PRINT "{ 7 }": COLOR 7, 0
        LOCATE 11, 57: PRINT "PROGRAM #7"
        LOCATE 13, 50: COLOR 15, 0: PRINT "{ 8 }": COLOR 7, 0
        LOCATE 13, 57: PRINT "PROGRAM #8"
        LOCATE 17, 20: COLOR 0, 15: PRINT "     Type M or m for FileManager menu     ": COLOR 15, 0



        DO: basic$ = INKEY$
         LOOP UNTIL basic$ = "1" OR basic$ = "2" OR basic$ = "3" OR basic$ = "4" OR basic$ = "5" OR basic$ = "6" OR basic$ = "7" OR basic$ = "8" OR basic$ = "M" OR basic$ = "m"
       

        SELECT CASE basic$
        CASE "1": RUN "PROGRAM #1"
        CASE "2": RUN "PROGRAM #2"
        CASE "3": RUN "PROGRAM #3"
        CASE "4": RUN "PROGRAM #4"
        CASE "5": RUN "PROGRAM #5"
        CASE "6": RUN "PROGRAM #6"
        CASE "7": RUN "PROGRAM #7"
        CASE "8": RUN "PROGRAM #8"
        CASE "m": CALL TipTop
        CASE "M": CALL TipTop
        END SELECT
        
END SUB

SUB BoxDraw

         CLS
         FOR SIDELINE = 1 TO 23
         PRINT CHR$(186); SPACE$(78); CHR$(186)
         NEXT SIDELINE
         LOCATE 3, 2: PRINT STRING$(78, 186)
         LOCATE 20, 2: PRINT STRING$(78, 186)

END SUB

SUB CreditSign
        LOCATE 2, 25: COLOR 15, 0: PRINT "FILE MANAGER  BY  CARMEN  PAONE": COLOR 7, 0

END SUB

SUB KillAll
        
        LOCATE 10, 1: FILES
        ON ERROR GOTO Handler
        LOCATE 21, 15: LINE INPUT "Name of file [plus extension]  "; FileName$
        IF FileName$ = "" THEN CALL TipTop

        LOCATE 22, 15: LINE INPUT "Are you certain? [Y or N]  "; certain$
        IF certain$ = "Y" OR certain$ = "y" THEN KILL FileName$: GOTO KillAll
        IF certain$ = "N" OR certain$ = "n" THEN CALL TipTop

KillAll:
        LOCATE 23, 25: PRINT FileName$; " killed";
        SLEEP 5
        CALL TipTop

END SUB

SUB KillBas
        
        LOCATE 10, 1: FILES "*.BAS"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Name of file:  "; FileName$
        IF FileName$ = "" THEN CALL TipTop

        LOCATE 19, 15: LINE INPUT "Are you certain? [Y or N]  "; certain$
        IF certain$ = "Y" OR certain$ = "y" THEN KILL FileName$ + ".BAS": GOTO KillBas
        IF certain$ = "N" OR certain$ = "n" THEN CALL TipTop

KillBas:

        LOCATE 21, 25: PRINT FileName$; " killed"
        SLEEP 5
        CALL TipTop


END SUB

SUB KillCom
        
        LOCATE 10, 1: FILES "*.COM"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Name of file:  "; FileName$
        IF FileName$ = "" THEN CALL TipTop

        LOCATE 19, 15: LINE INPUT "Are you certain? [Y or N]  "; certain$
        IF certain$ = "Y" OR certain$ = "y" THEN KILL FileName$ + ".COM": GOTO KillCom
        IF certain$ = "N" OR certain$ = "n" THEN CALL TipTop

KillCom:
        LOCATE 21, 25: PRINT FileName$; " killed"
        SLEEP 5
        CALL TipTop

END SUB

SUB KillExe

        
        LOCATE 10, 1: FILES "*.EXE"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Name of file:  "; FileName$
        IF FileName$ = "" THEN CALL TipTop

        LOCATE 19, 15: LINE INPUT "Are you certain? [Y or N]  "; certain$
        IF certain$ = "Y" OR certain$ = "y" THEN KILL FileName$ + ".EXE": GOTO KillExe
        IF certain$ = "N" OR certain$ = "n" THEN CALL TipTop

KillExe:
        LOCATE 21, 25: PRINT FileName$; " killed"
        SLEEP 5
        CALL TipTop


END SUB

SUB KillFile
        CLS
        CALL CreditSign
        LOCATE 3, 1: PRINT STRING$(80, 205)
        LOCATE 5, 20: PRINT "CHOICE OF FILES (SELECT A NUMBER FROM 1 TO 4)"
        LOCATE 7, 14: PRINT "1 - KILL BAS"
        LOCATE 7, 28: PRINT "2 - KILL COM"
        LOCATE 7, 42: PRINT "3 - KILL EXE"
        LOCATE 7, 56: PRINT "4 - KILL OTHERS"
        LOCATE 9, 1: PRINT STRING$(80, 205)
       
        
        DO: kill$ = INKEY$
        LOOP UNTIL kill$ = "1" OR kill$ = "2" OR kill$ = "3" OR kill$ = "4"
        SELECT CASE kill$
        CASE "1": CALL KillBas
        CASE "2": CALL KillCom
        CASE "3": CALL KillExe
        CASE "4": CALL KillAll
        END SELECT


END SUB

SUB NameAll

        LOCATE 11, 1: FILES
        ON ERROR GOTO Handler
        PRINT STRING$(80, 205)
        LOCATE 20, 15: LINE INPUT "Old filename [plus extension]:   "; OldName$
        LOCATE 21, 15: LINE INPUT "New filename [plus extension]:   "; NewName$
        IF NewName$ = "" THEN CALL TipTop ELSE NAME OldName$ AS NewName$
        LOCATE 22, 15: PRINT OldName$; "  renamed as  "; NewName$
        SLEEP 5
        CALL TipTop

END SUB

SUB NameBas

        
        LOCATE 10, 1: FILES "*.BAS"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Old file name:  "; OldName$
        LOCATE 19, 15: LINE INPUT "New file name:  "; NewName$
        IF NewName$ = "" THEN CALL TipTop ELSE GOTO NameBas


NameBas:
        NAME OldName$ + ".BAS" AS NewName$ + ".BAS"
        LOCATE 22, 15: PRINT OldName$; "  renamed as  "; NewName$
        SLEEP 5
        CALL TipTop

END SUB

SUB NameCom

        
        LOCATE 10, 1: FILES "*.COM"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Old file name:  "; OldName$
        LOCATE 19, 15: LINE INPUT "New file name:  "; NewName$
        IF NewName$ = "" THEN CALL TipTop ELSE GOTO NameCom


NameCom:
        NAME OldName$ + ".COM" AS NewName$ + ".COM"
        LOCATE 22, 15: PRINT OldName$; "  renamed as  "; NewName$
        SLEEP 5
        CALL TipTop

END SUB

SUB NameExe

        
        LOCATE 10, 1: FILES "*.EXE"
        ON ERROR GOTO Handler
        LOCATE 17, 15: LINE INPUT "Old file name:  "; OldName$
        LOCATE 19, 15: LINE INPUT "New file name:  "; NewName$
        IF NewName$ = "" THEN CALL TipTop ELSE GOTO NameIt


NameIt:
        NAME OldName$ + ".EXE" AS NewName$ + ".EXE"
        LOCATE 22, 15: PRINT OldName$; "  renamed as  "; NewName$
        SLEEP 5
        CALL TipTop


END SUB

SUB NameFile
        ON ERROR GOTO Handler
        CLS
        
        CALL CreditSign
        LOCATE 3, 1: PRINT STRING$(80, 205)
        LOCATE 5, 20: PRINT "CHOICE OF FILES (SELECT A NUMBER FROM 1 TO 4)"
        LOCATE 7, 14: PRINT "1 - NAME BAS"
        LOCATE 7, 28: PRINT "2 - NAME COM"
        LOCATE 7, 42: PRINT "3 - NAME EXE"
        LOCATE 7, 56: PRINT "4 - NAME OTHERS"
        LOCATE 9, 1: PRINT STRING$(80, 205)
      
       
        DO: name$ = INKEY$
        LOOP UNTIL name$ = "1" OR name$ = "2" OR name$ = "3" OR name$ = "4" OR name$ = "5" OR name$ = "6"
        SELECT CASE name$
        CASE "1": CALL NameBas
        CASE "2": CALL NameCom
        CASE "3": CALL NameExe
        CASE "4": CALL NameAll
        END SELECT

END SUB

SUB ReturnLine
        LOCATE 22, 23: PRINT "Type"
        LOCATE 22, 29: COLOR 15, 0: PRINT "R": COLOR 7, 0
        LOCATE 22, 33: PRINT "or"
        LOCATE 22, 37: COLOR 15, 0: PRINT "r": COLOR 7, 0
        LOCATE 22, 41: PRINT "for return to Main Menu"

        DO: return$ = INKEY$
        LOOP UNTIL return$ = "r" OR return$ = "R"
        SELECT CASE return$
        CASE "r": CALL TipTop
        CASE "R": CALL TipTop
        END SELECT

END SUB

SUB TipTop
         CLS
         CALL BoxDraw
         CALL CreditSign
         LOCATE 7, 25: COLOR 15, 0: PRINT "{ 1 }": COLOR 7, 0
         LOCATE 7, 33: PRINT "Run selected BASIC programs"
         LOCATE 8, 25: COLOR 15, 0: PRINT "{ 2 }": COLOR 7, 0
         LOCATE 8, 33: PRINT "Run any other BASIC program"
         LOCATE 9, 25: COLOR 15, 0: PRINT "{ 3 }": COLOR 7, 0
         LOCATE 9, 33: PRINT "Kill any file"
         LOCATE 10, 25: COLOR 15, 0: PRINT "{ 4 }": COLOR 7, 0
         LOCATE 10, 33: PRINT "Name any file"
         LOCATE 11, 25: COLOR 15, 0: PRINT "{ 5 }": COLOR 7, 0
         LOCATE 11, 33: PRINT "Quit to SYSTEM"
         LOCATE 16, 25: COLOR 15, 0: PRINT "SELECT A NUMBER FROM 1 TO 5": COLOR 7, 0
       
         DO: Number$ = INKEY$
         LOOP UNTIL Number$ = "1" OR Number$ = "2" OR Number$ = "3" OR Number$ = "4" OR Number$ = "5"
         SELECT CASE Number$
         CASE "1": CALL BasicSelect
         CASE "2": CALL AnyBasic
         CASE "3": CALL KillFile
         CASE "4": CALL NameFile
         CASE "5": CALL ToSystem
        
         END SELECT


END SUB

SUB ToSystem
        CLS
        SYSTEM
END SUB

