        '
        '    COPYRIGHT *c* 1989, Mike Shaffer - ALL RIGHTS RESERVED WORLDWIDE
        '    AUTHOR GRANTS RIGHTS TO USE FREELY PROVIDED THIS COPYRIGHT NOTICE
        '    IS INCLUDED
        '
        '
        '       SUB:            XSORT2
        '       AUTHOR:         Mike Shaffer (for Michael Welch)
        '       CREATION DATE:  27-June-89
        '       VERSION:        2.0
        '       LAST REVISION:
        '       PURPOSE:        This SUB will accept a string array and
        '                       sort it. The sorted element number map
        '                       is returned, and the source string array
        '                       is unchanged.
        '                       This program is based on a modified ripple 
        '                       sort algorithm originally written by Richard 
        '                       Ashwell III.
        '                       Through judicious use of better QB 
        '                       programming methods, I was able to speed 
        '                       his program up by a factor of nearly 10 
        '                       (e.g. to sort 2000 records, Quicksort 
        '                       takes about 2.5 minutes, MNTSORT takes 46.25 
        '                       seconds, while MWSSORT took 1.45 seconds!)
        '
        '       PASSED:         ar$()           => String array to be sorted
        '                       arN%            => Number of elements to sort
        '       RETURNS:        XSRTIME!        => Time it took to sort
        '                       ar%()           => element numbers in order
        '                       arn%            => will be trashed
        '
        '       CALLING CONV:   [CALL] XSORT2 [(] ar$(), arn%, ar%(), XSRTIME! [)]
        '
        '
        '       MISC NOTES:     plane% and wave% should be dimensioned to the
        '                       same number of elements contained in ar$ (or
        '                       more). This is currently set up for a max of 
        '                       2,000 entries.
        '
        '
        SUB xsort2(ar$(1),arn%,ar%(1),xsrtime!) STATIC
           '
           DIM plane%(2000),wave%(2000)
           FOR x%=1 TO 2000 : ar%(x%)=x% : NEXT
           '
           stime! = TIMER

           dreg%=1
           plane%(dreg%)=1
           wave%(dreg%)=arn%
           ereg%=1
           areg%=arn%

xsr2100:   IF (areg%-ereg%)<9 THEN GOTO xsr2230
           breg%=ereg%:creg%=areg%
xsr2120:   IF ar$(ar%(breg%))>ar$(ar%(creg%)) THEN GOTO xsr2170
xsr2130:   creg%=creg%-1
           IF creg%>breg% THEN GOTO xsr2120
           creg%=creg%+1
xsr2150:   dreg%=dreg%+1
           IF (breg%-ereg%)<(areg%-creg%) THEN GOTO xsr2220
           plane%(dreg%)=ereg%
           wave%(dreg%)=breg%
           ereg%=creg%
           GOTO xsr2100

xsr2170:   tmp%=ar%(breg%)
           ar%(breg%)=ar%(creg%)
           ar%(creg%)=tmp%
           goto xsr2190
xsr2180:   IF ar$(ar%(creg%))<ar$(ar%(breg%)) THEN GOTO xsr2210
xsr2190:   breg%=breg%+1
           IF creg%>breg% THEN GOTO xsr2180
           creg%=creg%+1
           GOTO xsr2150
xsr2210:   tmp%=ar%(breg%)
           ar%(breg%)=ar%(creg%)
           ar%(creg%)=tmp%
           GOTO xsr2130

xsr2220:   plane%(dreg%)=creg%
           wave%(dreg%)=areg%
           areg%=breg%
           GOTO xsr2100
xsr2230:   IF (areg%-ereg%+1)=1 THEN GOTO xsr2270
           FOR breg%=(ereg%+1) TO areg%
              FOR creg%=ereg% TO (breg%-1)
                 freg%=breg%-creg%+ereg%-1
                 IF ar$(ar%(freg%))<=ar$(ar%(freg%+1)) THEN
                    EXIT FOR
                 ELSE
                    tmp%=ar%(breg%)
                    ar%(breg%)=ar%(creg%)
                    ar%(creg%)=tmp%
                 END IF
              NEXT creg%
           NEXT breg%
xsr2270:   ereg%=plane%(dreg%)
           areg%=wave%(dreg%)
           dreg%=dreg%-1
           IF dreg%<>0 THEN GOTO xsr2100

           etime! = TIMER
           xsrtime! = etime! - stime!
           '
        END SUB


