' ******************************************
' ** Name:     RIPLSOR2.BAS               **
' ** Type:     Main Module                **
' ** Language  Microsoft QuickBASIC 4.00  **
' ** Author:   Mike Welch:  Dallas, TX    **
' ** Comments: The main module here is    **
' **           provided simply to be used **
' **           as an example sort.        **
' **       *   This is a modification of  **
' **           Mike Shaffer's (Dallas)    **
' **           modification of the ripple **
' ******************************************

DECLARE SUB XSort (Ar$(), Arn%, XSrTime!)
DIM SHARED Ar$(0 TO 1000)                         ' dimension sort array
CONST FALSE% = 0, TRUE% = NOT FALSE%              ' used for flags in sort

CLS                                               ' clear screen
PRINT "   *----------------------- Ripple Sort Test Run ------------------------*"
PRINT
PRINT "    - A modification of Richard F. Ashwell III's Mentat sort algorithim."
PRINT
PRINT "   You have 1 option in this test run.  You may have the output go to any"
PRINT "   of three devices; a disk file (any name), LPT1: (printer), or SCRN:,"
PRINT "   (the screen).  Note that if you want LPT1: or SCRN: you MUST include"
PRINT "   the colon [:] or an error message will occur."
PRINT
PRINT "   So, what'll it be? ([filename], [SCRN:], or [LPT1:]): ";
INPUT Device$                                     ' get output device
IF Device$ = "" THEN                              ' if user pressed ENTER
	BEEP                                         ' beep alert
	PRINT "   Error - program aborted"           ' print quit message and
	END                                          ' end program
END IF
Device$ = UCASE$(Device$)                         ' convert to uppercase
PRINT "   Okay, output will go to "; Device$;     ' print reply
PRINT "   Strike a key to continue";              ' print pause message
DO                                                ' and wait for a key
	LOCATE , , 1
LOOP WHILE INKEY$ = ""

	' open Device$.  BASIC will report any error messages as they occur.
OPEN Device$ FOR OUTPUT AS 1                      ' open device (file, etc.)

PRINT
PRINT "   Reading in data"

	' Read the random data included as DATA statements below
	' (1000 statements exist).
PRINT #1, "*-------------------- Unsorted Arrays ----------------------*"
FOR i% = 1 TO 1000                                ' get 1000 strings to sort
	READ Ar$(i%)                                 ' put data into array to sort
	PRINT #1, Ar$(i%)                            ' print non-sorted array to device
NEXT i%
PRINT
PRINT "Sorting...";
PRINT

BeginTime! = TIMER                                ' save beginning timer value
CALL XSort(Ar$(), 1000, XSrTime!)                 ' call sort routine
EndTime! = TIMER                                  ' stop the clock!
SortTime! = EndTime! - BeginTime!                 ' determine time required to sort

PRINT
PRINT CHR$(7); "Sort complete!: "; SortTime!; "required to sort 1000 records!"
PRINT
PRINT "Strike a key to see sorted output to "; Device$; "...";
DO
	LOCATE , , 1
LOOP WHILE INKEY$ = ""

PRINT #1, ""
PRINT #1, ""
PRINT #1, "*------------------------- Sorted Arrays ----------------------*"
FOR i% = 1 TO 1000
	PRINT #1, Ar$(i%)
NEXT i%

PRINT
PRINT "Demo Finished"
END


	' Sort data follows
DATA "DRHALO   EXE", "PRESENTS EXE", "SETUP    EXE"
DATA "CENTMED  FON", "CURSBOLD FON", "CURSIVE  FON", "CPU"
DATA "DISKETTE", "DRIVE", "SOFTWARE", "HARDWARE"
DATA "GRAPHICS", "MONITOR", "UTILITY", "BASCOM"
DATA "MICROSOF", "TRUMAN", "HISTORY", "GRETSORT"
DATA "F12X12   FON", "WEEKLY   NEW", "UNDO     CMD", "ABORT    CMD"
DATA "PASTE    CMD", "PRINT    COL", "EXIT     YOU", "DELETE   THI"
DATA "UNCASH   BIL", "WEAKSEAK DEK", "IBMBIO   COM", "IBMDOS   COM"
DATA "AUTOEXEC BAT", "COMMAND  COM", "CONFIG   SYS", "MAIN     BAT"
DATA "B1       COM", "BENHMARK", "BIOS     COM", "CHK-MHZ  COM"
DATA "CK-ANSI  BAT", "COLRTEST COM", "CORETEST COM", "CPU-ID   COM"
DATA "CPU-NDP  COM", "DIAG     COM", "DISKTEST EXE", "MAIN     MEN"
DATA "AUTOTEST EXE", "DMATEST  EXE", "DRIVSPEC COM", "EQSTATUS COM"
DATA "EQUIP    COM", "HD       COM", "IW-BENCH EXE", "MEMORY   EXE"
DATA "MENU        ", "LS       EXE", "OTHRCOPY LZH", "PATCH    COM"
DATA "PROUNLOK COM", "DISKCOPY", "TELEDISK EXE", "VIEWDISK EXE"
DATA "ZORKTOOL COM", "CLONE    EXE", "COPY-U   EXE", "MARBLMAD ZIP"
DATA "ZORK-ALL ARC", "BULKERAS COM", "COPYIIPC EXE", "DISKSPED BAT"
DATA "NOGUARD  COM", "NOKEY    COM", "PARMS    DOC", "COPYWDOC ZIP"
DATA "COPYWRIT COM", "RAMKEY   COM", "COPYWRIT", "SOLOBOOT COM"
DATA "UNGUARD  COM", "ZERODISK COM", "ASMGEN   COM", "BUB-DASM LZH"
DATA "DASSEMBL EXE", "DUMP     COM", "FILEDUMP COM", "DISASM"
DATA "SYMDEB   EXE", "PCWATCH  COM", "PCWATCH  PRO", "PCWATCH  SYS"
DATA "PCWATCH  TBL", "PCWATCHT ZIP", "PCWATCH", "UFORMAT  COM"
DATA "UOPT     COM", "U-FORMAT", "UZAP     COM", "UFILE    COM"
DATA "UDOCS    ZIP", "NEWEST   ZIP", "PFSWUNP  ZIP", "UNPROT"
DATA "ALF19UNP ZIP", "MENU     BAT", "MENU2       ", "CPU"
DATA "DISKETTE", "DRIVE", "SOFTWARE", "HARDWARE"
DATA "GRAPHICS", "MONITOR", "UTILITY", "BASCOM"
DATA "MICROSOF", "MIPS     COM", "PCS      COM", "TELEDISK EXE"
DATA "VIEWDISK EXE", "ZORKTOOL COM", "CLONE    EXE", "COPY-U   EXE"
DATA "MARBLMAD ZIP", "ZORK-ALL ARC", "BULKERAS COM", "COPYIIPC EXE"
DATA "COPYIIPC", "DISKSPED BAT", "SDIR     $$$", "SPEAKER  COM"
DATA "SPEED    COM", "SPINTEST COM", "SPINTIME COM", "SYS-INFO COM"
DATA "SYSID    EXE", "V20TIMER COM", "VIDEOTST EXE", "XTDIAG   COM"
DATA "DOSKNOWS EXE", "SCANNER  EXE", "PCBENCH  ZIP", "ANADISK  EXE"
DATA "BASUPROT COM", "TELEDISK EXE", "VIEWDISK EXE", "ZORKTOOL COM"
DATA "CLONE    EXE", "COPY-U   EXE", "DISKTEST EXE", "MAIN     MEN"
DATA "AUTOTEST EXE", "DMATEST  EXE", "MARBLMAD ZIP", "ZORK-ALL ARC"
DATA "BULKERAS COM", "COPYIIPC EXE", "DISKSPED BAT", "INT13    COM"
DATA "SDIR     $$$", "BLOAD    BAS", "PRNSDIR  BAS", "AEDIT    BAT"
DATA "AUTOFORM BAT", "CCOPY    BAT", "DELFILE  BAT", "FINDDATE BAT"
DATA "GAME     BAT", "SETDISK  COM", "DOS", "GRAPHICS BAT"
DATA "LINE     BAT", "MOUSE    BAT", "MOVE     BAT", "RAMDISK  BAT"
DATA "SETPATH  BAT", "UNC-ALL  BAT", "ADATER   COM", "ALARM    COM"
DATA "CHMOD    COM", "CLEAN    COM", "CS       COM", "TELEDISK EXE"
DATA "VIEWDISK EXE", "ZORKTOOL COM", "CLONE    EXE", "COPY-U   EXE"
DATA "MARBLMAD ZIP", "ZORK-ALL ARC", "BULKERAS COM", "COPYIIPC EXE"
DATA "DISKSPED BAT", "D        COM", "DEBUG    COM", "DECIDE   COM"
DATA "DEFRAG   COM", "ALTSROFF COM", "ASSIGN   COM", "BASICA   COM"
DATA "BROWSE   COM", "CACHE    COM", "CHD      COM", "CHKDSK   COM"
DATA "EDIT     COM", "EPSONFX  COM", "EXE2BIN  COM", "EXE2COM  COM"
DATA "F11F12   COM", "FACECLOK COM", "FORMTOOL HLP", "FORMTOOL MNU"
DATA "FORMTOOL", "FASTDRV  COM", "TELEDISK EXE", "VIEWDISK EXE"
DATA "ZORKTOOL COM", "CLONE    EXE", "COPY-U   EXE", "MARBLMAD ZIP"
DATA "ZORK-ALL ARC", "BULKERAS COM", "MAKELABL BAS", "FASTBACK"
DATA "RECORD   BAS", "GAME     BAT", "GAME1    MEN", "GAME2    MEN"
DATA "GAME3    MEN", "GAMES", "TUNES    MEN", "BCAT     DAT"
DATA "COPYIIPC EXE", "DISKSPED BAT", "FATBACK  COM", "FILESIZE COM"
DATA "FILLDISK COM", "FIND     COM", "FINDDUPE COM", "FLUSHOT  COM"
DATA "FORMAT   COM", "FREERAM  COM", "GCOPY    COM", "CPU"
DATA "DISKETTE", "DRIVE", "SOFTWARE", "HARDWARE"
DATA "GRAPHICS", "MONITOR", "UTILITY", "BASCOM"
DATA "MICROSOF", "HOLD        ", "DOC4PROG", "DIRENAME COM"
DATA "DIRSIZE  COM", "DIRSORT  COM", "DISCLOCK COM", "DISKCOMP COM"
DATA "DISKTYPE COM", "ED       COM", "CONVERT  DOC", "RPRN     DOC"
DATA "BANNER   COM", "DTP      BAT", "BOLDL    FON", "BOLDS    FON"
DATA "F        001", "FINGPANT", "HERC     FON", "WEEKLY   NEW"
DATA "UNDO     CMD", "ABORT    CMD", "PASTE    CMD", "PRINT    COL"
DATA "EXIT     YOU", "DELETE   THI", "UNCASH   BIL", "WEAKSEAK DEK"
DATA "MINI     FON", "PAINT    BAT", "PLAINL   FON", "PLAINS   FON"
DATA "ROMANL   FON", "ROMANS   FON", "MOUSE    LZH", "PIC"
DATA "CFG      BAK", "FORMTOOL DAT", "FORMTOOL EXE", "FORMTOOL TBL"
DATA "PC106    FNT", "PC106B   FNT", "PRNTUTIL EXE", "TBL      BAK"
DATA "ALLFORMS ZIP", "FORMMADE", "BLOD2PUT COM", "FONTMOVE COM"
DATA "FONTSDJ  DIC", "FONTSDJ  WID", "FONTSLJ  WID", "FONTSLW  DIC"
DATA "FP       HLP", "FP", "FP       CVT", "FPPRINT  DEF"
DATA "GRAB2BAS BAS", "MASTER   FNT", "MASTER   DEF", "READMAC  COM"
DATA "SMOOTH   PS ", "SNAP2ART COM", "SNAPSHOT COM", "SYSTEM   FNT"
DATA "UARTPAT2 PS ", "ALLPUB   ZIP", "FP-MAPS  ZIP", "PUB"
DATA "GRID     PUB", "HALO     CNF", "HALOIBM  DEV", "HALOVRI  DEV"
DATA "DRHALO   EXE", "GRAB     EXE", "PRESENTS EXE", "HALO"
DATA "SETUP    EXE", "CENTITAL FON", "CENTMED  FON", "CURSBOLD FON"
DATA "CURSIVE  FON", "F12X12   FON", "F16X16   FON", "F18X28   FON"
DATA "F6X9     FON", "F8X8A    FON", "F9X14    FON", "GOTHIC   FON"
DATA "GREEK    FON", "HALO201  FON", "HALO202  FON", "ITALIC   FON"
DATA "ROMAN1   FON", "ROMAN2   FON", "ROMAN3   FON", "DRHALO   HLP"
DATA "DISKSPED BAT", "D        COM", "DEBUG    COM", "DECIDE   COM"
DATA "DEFRAG   COM", "ALTSROFF COM", "ASSIGN   COM", "BASICA   COM"
DATA "BROWSE   COM", "CACHE    COM", "HALOEPSN PRN", "EXAMPLE  PIC"
DATA "GOTHIC   FNT", "HP7510A  PAL", "HPG      DIR", "HPG      EXE"
DATA "HARVARD", "HPG      CFG", "ITALIC1  FNT", "ITALIC2  FNT"
DATA "MPS2000  PAL", "ROMAN1   FNT", "ROMAN2   FNT", "SCRIPT1  FNT"
DATA "SCRIPT2  FNT", "SSERIF1  FNT", "SSERIF2  FNT", "VDI      OVL"
DATA "5           ", "BARINCOM CHT", "MEATBIRD CHT", "MINCOME  CHT"
DATA "MINCOME2 CHT", "GRAPH", "PIE-OW   CHT", "HPG      DIR"
DATA "BORDERS1 BIC", "BORDERS1 BNM", "BORDERS1 NUM", "BREMEN   FNT"
DATA "CAFE     FNT", "COMPUTER FNT", "CUSTOM   SHP", "CUSTOM   SDR"
DATA "PM", "DEVILLE  FNT", "EDITOR   FNT", "EXAMINER FNT"
DATA "FONTS1   FIC", "CPU", "DISKETTE", "DRIVE"
DATA "SOFTWARE", "HARDWARE", "GRAPHICS", "MONITOR"
DATA "UTILITY", "BASCOM", "MICROSOF", "FONTS1   FSZ"
DATA "FONTS4   FNM", "FONTS4   NUM", "FONTS4   FSZ", "GAMMON   FNT"
DATA "GOTHIC   FNT", "HAMPTON  FNT", "JOYCE    FNT", "LCD      FNT"
DATA "MAIN     SHP", "NEWS18   FNT", "NEWS18B  FNT", "NEWS18I  FNT"
DATA "OFFICE   FNT", "OSLO20B  FNT", "OSLO20BC FNT", "PARIS    FNT"
DATA "PARK18   FNT", "PARK18B  FNT", "PARK18I  FNT", "PATTICON SHP"
DATA "PM       EXE", "PM       PRN", "PM-IMADE ZIP", "PMAG1    SDR"
DATA "PMAG1    SHP", "PMTOOLS  EXE", "PMTOOLS  DOC", "PUBDOM1  SHP"
DATA "PUBDOM1  SDR", "QUILL    FNT", "RHODES   FNT", "ROMAN    FNT"
DATA "SCRIBE   FNT", "SET      UP ", "SMALLCAP FNT", "STANDARD SDR"
DATA "STANDARD SHP", "TRIBUNE  FNT", "TWIG     FNT", "UTOPIA   FNT"
DATA "WESTERN  FNT", "ARTCON14 DOC", "TOOLS", "ARTCON14 EXE"
DATA "SDIR     $$$", "B-BACKUP BAT", "COMPBACK BAT", "DAYBACK  BAT"
DATA "FASTBACK COM", "FRESTORE COM", "MAKELABL BAS", "FASTBACK"
DATA "RECORD   BAS", "GAME     BAT", "GAME1    MEN", "GAME2    MEN"
DATA "GAME3    MEN", "DRHALO   EXE", "GRAB     EXE", "PRESENTS EXE"
DATA "HALO", "SETUP    EXE", "CENTITAL FON", "CENTMED  FON"
DATA "CURSBOLD FON", "CURSIVE  FON", "F12X12   FON", "GAMES"
DATA "TUNES    MEN", "BCAT     DAT", "GAME1", "1KPYMID"
DATA "CAT      DAT", "RND      DAT", "BO_TITLE EXE", "PYRAMID  EXE"
DATA "BO_SCR   PIC", "BO_SHP   PIC", "FNT      PIC", "PYRAMID1 PIC"
DATA "PYRAMID2 PIC", "PYRAMID3 PIC", "PYRAMID4 PIC", "WINNER   PIC"
DATA "PYRAMID  SCR", "PYMIDDOC ZIP", "CENTPEED COM", "CENTPEED"
DATA "CELL     CGA", "EAGLE", "CHAR     CGA", "ELEV     CGA"
DATA "FINP     CGA", "FONT     CGA", "LOGO     CGA", "STAT     CGA"
DATA "START    COM", "MAP0     DAT", "MAP1     DAT", "JOYSTICK CTP"
DATA "TOPTENA  CTP", "MAPU     DAT", "MUSC     DAT", "MUSI     DAT"
DATA "EAGLE    EXE", "MONOCODE 001", "MONOCODE 003", "MONOGRAF GRA"
DATA "MONOPOLY", "MONOPOLY COM", "MORIA    CNF", "MORIA"
DATA "JOYSTICK CTP", "TOPTENA  CTP", "MORIA    EXE", "MORIA    SCR"
DATA "NATION   EXE", "NATION", "MAP         ", "BIMAGE1  DAT"
DATA "BIMAGE1B DAT", "BIMAGE2  DAT", "NINJA", "BIMAGE2B DAT"
DATA "FONT     DAT", "FONT2    DAT", "FONT2B   DAT", "FONTB    DAT"
DATA "IMAGES   DAT", "IMAGESB  DAT", "PF       DAT", "PFB      DAT"
DATA "NINJA    EXE", "NINJAX   ZIP", "BIZERK   COM", "BJTALK   COM"
DATA "DRAGONS  COM", "GO-MOKU  COM", "HARDHAT  COM", "HOPPER   COM"
DATA "OTHERS", "MZPACMAN COM", "OFFROAD  COM", "PACKMAN  COM"
DATA "QUBERT   COM", "SMINER   COM", "SOLITARE COM", "WEEKLY   NEW"
DATA "UNDO     CMD", "ABORT    CMD", "PASTE    CMD", "PRINT    COL"
DATA "EXIT     YOU", "DELETE   THI", "UNCASH   BIL", "WEAKSEAK DEK"
DATA "GO-MOKU  HLP", "DRAGONS  HST", "BS       SCO", "HOPPER   SCO"
DATA "SMINERHS ZZZ", "PANGO    COM", "PANGO", "PANGO    HGH"
DATA "HISCORE     ", "MAP      BIN", "QUAKE", "QUAKE    EXE"
DATA "BOARD       ", "RISK     EXE", "RISK", "HIGHSCOR DAT"
DATA "MISFAC   DAT", "STRIKER", "STRIKER  COM", "STRKLOGO DAT"
DATA "STRKPARM DAT", "TUNNELS  DAT", "XONIX    BIN", "XONIX    COM"
DATA "BASRUN   EXE", "XONIX", "HISCORES XNX", "TOPGUN   COM"
DATA "3DEMON   COM", "3DEMON", "3-DEMON  HI1", "CASTLE   COM"
DATA "CASTLE", "CASTLE   RAN", "ABM      COM", "SMGAME   COM"
DATA "BABY     COM", "BEAST    COM", "CHESS1   COM", "GRAPHY   COM"
DATA "JANITJOE COM", "JJ       DAT", "MAXGAME  COM", "MAXHEAD  COM"
DATA "MAXHEAD2 DAT", "PITFALL  COM", "ROUND42  EXE", "SHOAX    COM"
DATA "TEM-INS  EXE", "TEMPLE   EXE", "TNUKE    COM", "UNO      COM"
DATA "READMAC  COM", "GIFMAC", "ALLMAC   ZIP", "GREY     LZH"
DATA "ASTRO    COM", "EM       COM", "INVADERS COM", "LOCKERS"
DATA "OTHERS", "PARATROP COM", "TIMING   COM", "PIANOMAN LZH"
DATA "PIANO", "CHACONNE COM", "CMINOR   COM", "TUNES"
DATA "ENTERTAN COM", "FESTBERG COM", "INVENTN4 COM", "JBOND    COM"
DATA "PYTHON   COM", "QNAVEE   COM", "REDROSE  COM", "RKTYTKTY COM"
DATA "SYNCLOCK COM", "TURKISH  COM", "TVTUNE   COM", "WACHTAUF COM"
DATA "WILLOW   COM", "WILLTELL COM", "PLAY     DAT", "MAGIC    COM"
DATA "MASTER   COM", "PINBALL", "TOMATO   COM", "TWILZONE COM"
DATA "APRIL    COM", "BACKTALK COM", "BUG      COM", "DECEIVE  COM"
DATA "DRAIN    COM", "PRANK", "DRIP     COM", "DUMB     COM"
DATA "EYE      COM", "FAKE123  COM", "FIX      COM", "FLIP     COM"
DATA "FUNNYDOS EXE", "HELPME   COM", "HOTBOOT  COM", "MAC      COM"
DATA "MRORGAN  COM", "QQ       EXE", "ATITDOC  ZIP", "COVER    SCR"
DATA "INST0    SCR", "INST1    SCR", "SCR0     SCR", "SCR4     SCR"
DATA "PARTS    BAS", "N1       IMG", "N3       IMG", "TEXTSTUF ZIP"
DATA "TEXTFILE", "CRYPTOR  ZIP", "DOCMAKER TXT", "DOCMAKER COM"
DATA "MIND     COM", "POLSCALE COM", "TIMEDON  FRM", "HOLDTANK"
DATA "DAZZLER  COM", "MSG1        ", "OTHRHOLD LZH", "3DMENU   ZIP"
DATA "BACKDATA BAT", "MAINDATA DAT", "MBASE", "MAINDATA EXE"
DATA "MBASE    EXE", "PRNTDATA EXE", "MAINDATA KEY", "FRAMTEL  BAS"
DATA "FRAMTEL  BAT", "BUSINESS TEL", "RICHLAND TEL", "PHONE"
DATA "FRIEND   TEL", "1RECORD     ", "FINDALL  BAS", "HIGHNUMB BAS"
DATA "FINDALL  COM", "TESTDATA ZIP", "DEMO     ZZZ", "TOOLS"
DATA "AUTODDC  ASP", "CHKSUM   COM", "CRC      COM", "CRC2     COM"
DATA "DSZ      COM", "GO       BAT", "PCPLUS   KEY", "PCPLUS   PRM"
DATA "MODEM", "PCSETUP  EXE", "PROCOMM  DIR", "PROZ     COM"
DATA "ALSCREEN ZIP", "LEN      DOC", "LEN2     DOC", "SCREENS"
DATA "NPAD     COM", "TINYPRT  COM", "PD       COM", "PRNAPPL  LZH"
DATA "PRTFONT  ARC", "SDIR     $$$", "CONTROL", "SIDEWAYS COM"
DATA "TSR      LZH", "BOXLABEL COM", "COVER    COM", "LAB-DOC  ZIP"
DATA "LBL      COM", "LBL35V1  EXE", "LABEL", "STARLAB  EXE"
DATA "RETLABEL DAT", "ADDLABEL DAT", "PROGRAM  BAT", "A86STUFF LZH"
DATA "A86", "DOSBAS   ZIP", "JUSTBASC", "BIGPROGS"
DATA "MICKEY   BAS", "CALENDAR BAS", "CHECKERS BAS", "CLOCK    BAS"
DATA "COMPAT   BAS", "GRAPHIT  BAS", "HANGMAN  BAS", "ELECTION BAS"
DATA "MATCHIT  BAS", "WEEKLY   NEW", "UNDO     CMD", "ABORT    CMD"
DATA "PASTE    CMD", "PRINT    COL", "EXIT     YOU", "DELETE   THI"
DATA "UNCASH   BIL", "WEAKSEAK DEK", "MENU     BAS", "ORGAN    BAS"
DATA "TICTAC   BAS", "PCWORM2  BAS", "CARWARS  BAS", "PCWORM   BAS"
DATA "NOTES    BAS", "ZAPEM    BAS", "PUZZLE   BAS", "READ-BAS COM"
DATA "BAS2FORT ZIP", "LINK     EXE", "MASM     EXE", "PROGLANG"
DATA "MASM", "ALLASM   ZIP", "SOURCE.COD", "BOOK-ASM ZIP"
DATA "GMAKE    COM", "MOUSE", "GMAKE1   EXE", "LOTUS    GMK"
DATA "MENUS", "LOTUS    MNU", "POP-UP   GMK", "POP-UP   MNU"
DATA "TXT2PAS  COM", "TP       BAT", "TURBO    COM", "PASCAL"
DATA "CUBE     PAS", "T2C      ZIP", "MS-T2C", "EXAMPLES ZIP"
DATA "PAS-SOUR ZIP", "SOURCE.COD", "TINST    MSG", "TINST    DTA"
DATA "TURBO    MSG", "TURBO.MSG", "ASM2PAS  COM", "SCAN     EXE"
DATA "PCMAC    ASM", "COMPILE  BAT", "TXT2C    COM", "POWERC"
DATA "MIX      EXE", "PC       EXE", "PCL      EXE", "PCO      EXE"
DATA "ALLOC    H  ", "ASSERT   H  ", "BIOS     H  ", "CONIO    H  "
DATA "CTYPE    H  ", "DIR      H  ", "DIRECT   H  ", "DOS      H  "
DATA "ERRNO    H  ", "MERGE    EXE", "COMPILED", "WORKS    ZIP"
DATA "LOCKING  H  ", "STAT     H  ", "TIMEB    H  ", "SYS"
DATA "TYPES    H  ", "UTIME    H  ", "C-FILES  ZIP", "QSORT    C  "
DATA "HOLD", "QSORT    EXE", "GETPARM  EXE", "GETAKEY  EXE"
DATA "GETAKEY  C  ", "CCLS     C  ", "CCLS     EXE", "CHILD    C  "
DATA "WORKSOK", "QSORT    C  ", "SHELL    C  ", "BARCHART C  "
DATA "PIECHART EXE", "Q        BAT", "BC       EXE", "LIB      EXE"
DATA "QB", "LINK     EXE", "QB       EXE", "MYLIB    HED",
DATA "QB       HLP", "QB       INI", "NOCOM    OBJ", "NOEM     OBJ"
DATA "QB       PIF", "INTRPT   QLB", "MYLIB    QLB", "MASSSORT BAS"
DATA "MAINDATA DAT", "RIPLSORT BAS", "1000RECS    ", "DATA     BAS"
DATA "HEX2BIN  COM", "MISCBOOK ZIP", "QSORT2   SUB", "BOOK"
DATA "COOLGRID SUB", "CKDSKSPC SUB", "LOADPIC  ZIP", "MISCSUBS ZIP"
DATA "HOLDSTUF ZIP", "PCSPELL  LZH", "HOLDTANK", "LIBDEMO  BAS"
DATA "WARMBOOT BAT", "FONT     BAS", "BCOM40   LIB", "BQLB40   LIB"
DATA "BRUN40   LIB", "INTRPT   LIB", "LIB", "MYLIB    LIB"
DATA "ADVBAS   LIB", "OBJECT   ARC", "ADDLINE# COM", "BAS2C    LZH"
DATA "BAS2SB   COM", "BLOD2PUT COM", "CAPTURE  DOC", "CAPTURE  COM"
DATA "GRAB2BAS BAS", "GRID     COM", "HELP     DOC", "HELP     COM"
DATA "OPTCALL  LZH", "PRNTSUBS COM", "QBUTIL40 EXE", "QLBDUMP  COM"
DATA "REMLINE  COM", "SDIR     $$$", "UNCOMGEN BAS", "SOURCE   ZIP"
DATA "MYERS    DAT", "PLOTTER  BAS", "BAR      BAS", "DBASELOC    "
DATA "MBASE", "FIELD       ", "DATA     BAS", "EXAMDATA BAS"
DATA "FIXMDATA BAS", "HIGHNUMB BAS", "MAINDATA BAS", "MBASE    BAS"
DATA "PRNTDATA BAS", "MAINDATA DAT", "PRNTDATA QBO", "PROGRUN  XXX"
DATA "MBASESRC ZIP", "MWSORT   BAS", "MWSORT   EXE", "MWSORT2  EXE"
DATA "MWSORT   TBO", "SORTS", "PROGRUN  XXX", "MWSORT   BAS"
DATA "MAINDATA DAT", "MWSORT   EXE", "TB       EXE", "TBCONFIG TB "
DATA "TBHELP   TBH", "ADVBAS   QLB", "ADVTEST  BAS", "ADVBAS"
DATA "BUBBLEST BAS", "CSORT    QB4", "CSORT    BAS", "MNTSORT  LZH"
DATA "MWMSORT  BAS", "MWSORT   QB4", "MWSSRT   COM", "RIPLSORT BAS"
DATA "SPLITSRT BAS", "SPLIT2ST BAS", "DEFAULT     ", "FIXQP    BAS"
DATA "HDEFAULT    ", "QP       BAT", "QPRLDB   OV2", "QUIKPRO"
DATA "QPRLDB   SRT", "QUIKDOC3    ", "QUIKDOK     ", "QUIKMENU    "
DATA "QUIKPRO5    ", "QUIKPRT4    ", "QXDOC3      ", "RANDPRT     "
DATA "RANDWRT     ", "PHONEY   FIL", "FAKE     FIL", "JOKE     THN"
DATA "ANOTHER  FIL", "MAKETHIS UP", "EXTRA    DAT", "MONEY4   NIL"
DATA "EXTRA    CAS", "FREEWARE XXX", "XXX      FRE", "GMWELCH  FIL"
DATA "ANOTHER  TWO", "WEEKLY   NEW", "UNDO     CMD", "ABORT    CMD"
DATA "PASTE    CMD", "PRINT    COL", "EXIT     YOU", "DELETE   THI"
DATA "UNCASH   BIL", "WEAKSEAK DEK", "MEEKLEAK FEK", "ONLYYOU  SMO"
DATA "ADEREKFX DFJ", "EIRIELFK FEL", "FELDKFIE DFO", "FLDFIKSI LFE"
DATA "LSDFIOER KDP", "LIREEICX DME", "EEEMEEME FEO", "FIRELFDD ERE"

SUB XSort (Ar$(), Arn%, XSrTime!)

'    COPYRIGHT *c* 1989, Mike Shaffer - ALL RIGHTS RESERVED WORLDWIDE
'    AUTHOR GRANTS RIGHTS TO USE FREELY PROVIDED THIS COPYRIGHT NOTICE
'    IS INCLUDED
'
'
'       SUB:            XSORT
'       AUTHOR:         Mike Shaffer (for Michael Welch)
'       CREATION DATE:  27-June-89
'       VERSION:        2.1
'       LAST REVISION:  30-June-89 by Michael Welch
'       REVISION HIST.: After receiving the XSORT algorithm, Mike Welch
'                       spent approximately 7 hours reformatting the code
'                       such that abides by the rules of modular
'                       programming (i.e., "top-down" method).  This
'                       process involved rearranging the source code and
'                       removing the 13 or so GOTO statements and line
'                       labels.  Note that doing so also slowed the sort
'                       down a slight amount as the DO-LOOP statements
'                       take QuickBASIC longer to execute.  If about an
'                       extra 10 seconds per 1000 sorted arrays is not worth
'                       the modular style, stick to Mike Shaffer's ver. 2.0.
'                       Note that the RIPLSORT file is a modification of the
'                       actual MNTSORT and is copyright by Mike Welch of 
'                       Dallas.  But, on this sort, RIPLSOR2, a modification of
'                       Mike Shaffer's (Dallas) sort, Mike Shaffer has all
'                       of the copyrights.
'       PURPOSE:        This SUB will accept a string array and
'                       sort it. The same string array is returned
'                       in sorted order. This program is based
'                       on a modified ripple sort algorithm
'                       originally written by Richard Ashwell III.
'                       Through judicious use of better QB
'                       programming methods, I was able to speed
'                       his program up by a factor of nearly 10
'                       (e.g. to sort 2000 records, Quicksort
'                       takes about 2.5 minutes, MNTSORT takes 46.25
'                       seconds, while MWSSORT took 1.45 seconds!)
'
'       PASSED:         Ar$()           => String array to be sorted
'                       Arn%            => Number of elements to sort
'       RETURNS:        XSRTIME!        => Time it took to sort
'                       Ar$()           => in modified order
'                       Arn%            => will be trashed
'
'       CALLING CONV:   [CALL] XSORT [(] Ar$(), arn%, XSRTIME! [)]
'
'
'       MISC NOTES:     plane% and wave% should be dimensioned to the
'                       same number of elements contained in Ar (or
'                       more). This is currently set up for a max of
'                       2,000 entries.
'
'
		
'
DIM Plane%(0 TO 2000), Wave%(0 TO 2000)

STime! = TIMER                       'Get start time

DReg% = 1                            ' \
Plane%(DReg%) = 1                    '  \ Initialize program's
Wave%(DReg%) = Arn%                  '  /   work variables
Ereg% = 1                            ' /
AReg% = Arn%                         '/

DO
	EndLoop = FALSE%
	Begin = FALSE%
	DO WHILE (AReg% - Ereg%) > 8
		BReg% = Ereg%: CReg% = AReg%
		DO
			IF Ar$(BReg%) > Ar$(CReg%) THEN
				Flag2 = FALSE%
				SWAP Ar$(CReg%), Ar$(BReg%)
				DO
					IF Ar$(CReg%) < Ar$(BReg%) THEN
						SWAP Ar$(CReg%), Ar$(BReg%)
						CReg% = CReg% - 1
						Flag2 = TRUE%
						EXIT DO
					END IF
					BReg% = BReg% + 1
				LOOP WHILE CReg% > BReg%
				CReg% = CReg% + 1
				Flag1 = FALSE%
				IF Flag2 = FALSE% THEN EXIT DO
			END IF
		CReg% = CReg% - 1
		LOOP WHILE CReg% > BReg%
		IF Flag1 = TRUE% THEN CReg% = CReg% + 1
		Flag1 = TRUE%
		DReg% = DReg% + 1
		IF (BReg% - Ereg%) < (AReg% - CReg%) THEN
			Plane%(DReg%) = CReg%
			Wave%(DReg%) = AReg%
			AReg% = BReg%
			Begin = TRUE%
			EXIT DO
		END IF
		Plane%(DReg%) = Ereg%
		Wave%(DReg%) = BReg%
		Ereg% = CReg%
		Begin = TRUE%
		EXIT DO
	LOOP
	IF Begin = FALSE% THEN
		IF NOT (AReg% - Ereg% + 1) = 1 THEN
			FOR BReg% = (Ereg% + 1) TO AReg%
				FOR CReg% = Ereg% TO (BReg% - 1)
					Freg% = BReg% - CReg% + Ereg% - 1
					IF Ar$(Freg%) <= Ar$(Freg% + 1) THEN
						EXIT FOR
					ELSE
						SWAP Ar$(Freg%), Ar$(Freg% + 1) ' Swap elements
					END IF
				NEXT CReg%
			NEXT BReg%
		END IF
		Ereg% = Plane%(DReg%)
		AReg% = Wave%(DReg%)
		DReg% = DReg% - 1
		IF DReg% = 0 THEN
			EndLoop = TRUE%
		END IF
	END IF
LOOP UNTIL EndLoop = TRUE%

Etime! = TIMER
XSrTime! = Etime! - STime!

END SUB

